<?php if ( ! defined( 'ABSPATH' )  ) die; // Cannot access directly.

//
// Set a unique slug-like ID
//
$prefix = MD5(CX_THEMES_NAME);

//
// Create options
//
CSF::createOptions( $prefix, [
    'menu_title'      => CX_THEMES_NAME.'主题配置',
    'framework_title' => CX_THEMES_NAME.'主题配置面板 <small>'.CX_THEMES_VERSION.'</small>', 
    'menu_slug'       => 'cxwp-theme-panel',
] );

function __theme_author_desc(){
    return '<div class="groups_title">
    <h3>亲爱的Meteor主题用户，您好!</h3>
    <p>欢迎使用Meteor主题,我们深感荣幸能获得您的支持。一个卓越的网站是大家共同努力的结果，让我们携手确保其安全无虞！</p>
    <p><strong style="color:#f66">1、主题来源安全建议：</strong><br/>为了保障您的网站安全，推荐通过WordPress官方网站、信誉良好的第三方站点、以及直接从主题作者的官方网站下载主题。这样可以有效避免潜在的恶意代码风险。<br/>我们的网站网址是：<a href="https://www.xhtheme.com">www.xhtheme.com</a></p>
    <p><strong style="color:#f66">2、选择可信赖的主机服务：</strong><br/>优质的主机服务是网站安全的基础。务必谨慎挑选，以保护我们辛勤创建的网站及宝贵的用户信息免遭滥用（推荐阿里云、腾讯云等大牌服务商）。</p>
    <p><strong style="color:#f66">3、强化账户安全：</strong><br/>避免使用“admin”、“root”等常见用户名作为管理员账号。同时，设置强密码，避免因弱口令导致的网站被侵入。您的小小举措，将大大增强网站的安全性。</strong></p>
    <br/>
    <h3>售后联系方式</h3>
    <p><strong style="color:#444">作者QQ: 1021680574</strong>（仅限商业主题、定制需求、赞助支持、会员等用户提供即时售后服务）</p>
    <p><strong style="color:#444">QQ群: 945032172 </strong>(免费用户欢迎加入，互助解答）</p>
    <p><strong style="color:#444">微信公众号: 星河网络开发 </strong>(免费用户问题，2个工作日内回复，可直接在公众号消息框发送您的问题）</p>
    <p class="support-notice">尊敬的用户，我们目前仅向付费会员提供即时QQ消息的售后咨询服务。考虑到团队的工作负荷，我们恳请所有用户的理解。为了更有效地分配资源，免费用户可以通过我们的官方公众号提交反馈，这将有助于减轻客服的工作压力。感谢您的配合！</p>
    <br/>
    <h3>主题在线文档</h3>
    <p>1. <a href="https://www.xhtheme.com/docs/wpword">WordPress通用文档</a> （建议快速浏览）</p>
    <p>2. <a href="https://www.xhtheme.com/docs/meteor">Meteor主题使用教程</a> </p>
    <p>3. 借力搜索引擎，WordPress作为一个成熟的CMS程序，很多问题网上都有很全面的教程！ </p>
    <br/>
    <h3>支持我们</h3>
    <div class="theme-autor-qrcodebox">
        <div class="item">
            <div class="cxory_weixin_qrcode" style="width:160px;height:160px"></div>
            <p>扫码关注微信公众号</p>
        </div>
        <div class="item">
            <div class="cxory_weixin_zzcode" style="width:160px;height:160px"></div>
            <p>微信扫码赞助支持</p>
        </div>
        <div class="item">
            <div class="cxory_qq_author" style="width:160px;height:160px"></div>
            <p>扫码加作者QQ好友</p>
        </div>
    </div>
    <br/>
    <br/>
    </div>
    <style>
    .csf-options .csf-nav .csf-tab-item:nth-child(1) a{
        background: linear-gradient(160deg, #fe4f70 0%, #ffa387 51%, #fe4f70 100%) !important;
        background-size: 200% auto !important;
        color: #fff !important;
    }
    </style>
    ';
}

function __theme_author_pro(){
    ob_start();
    ?>
    <style>
        .pading-0 {
            padding:0
        }
    </style>
    <iframe id="xhthemeIframe" src="<?php echo admin_url('admin-ajax.php?action=xhthemeIframe');?>" style="width:100%;border:none;" frameborder="0" width="100%" scrolling="no"></iframe>
    <script>
        function resizeIframe() {
            var iframe = document.getElementById('xhthemeIframe');
            // 确保可以访问 iframe 的内容
            if (iframe.contentWindow) {
                // 获取 iframe 文档的高度
                var body = iframe.contentWindow.document.body;
                var html = iframe.contentWindow.document.documentElement;

                var height = Math.max(body.scrollHeight, body.offsetHeight, 
                                    html.clientHeight, html.scrollHeight, html.offsetHeight);
                // 设置 iframe 的高度
                iframe.style.height = height + 'px';
            }
        }
        // 等待 iframe 加载完成后调整大小
        document.getElementById('xhthemeIframe').onload = resizeIframe;
    </script>
    <?php
    return ob_get_clean();
}


//
// Create a section
//
CSF::createSection( $prefix, [
    'title'       => 'Meteor主题-高级版',
    'icon'        => 'cxicon cxicon-wordpress',
    'description' => __theme_author_pro(),
    'descclass'   => 'pading-0',
    'fields'      => []
]);
CSF::createSection( $prefix, [
  'title'       => '主题说明',
  'icon'        => 'cxicon cxicon-index-black',
  'description' => __theme_author_desc(),
  'fields'      => []
] );
CSF::createSection( $prefix, [
    'id'    => 'page_fields',
    'title' => '页面布局',
    'icon'  => 'cxicon cxicon-desktop',
]);

// Header 配置项
CSF::createSection( $prefix, [
    'parent'      => 'page_fields',
    'title'       => '顶部配置',
    'description' => '调整网站基本功能配置项。',
    'fields'      => [

        [
            'id'      => 'site-logo',
            'type'    => 'upload',
            'title'   => '上传网站Logo图片',
            'library' => 'image',
            'after'    => '<p>该Logo将显示在前台顶部Header模块中！</p>',
            'button_title' => '上传Logo', 
            'default' => cx_assetsurl('logo.png',false), 
            'preview' => true, 
        ],[
            'id'      => 'site-logo-dark',
            'type'    => 'upload',
            'title'   => '暗黑模式网站Logo图片',
            'library' => 'image',
            'after'    => '<p>该Logo将显示在前台顶部Header模块中，留空则调用默认logo图片！</p>',
            'button_title' => '上传Logo', 
            'default' => cx_assetsurl('logo-dark.png',false), 
            'preview' => true, 
        ]

    ]
]);

// 站点首页配置项
CSF::createSection( $prefix, [
    'parent'      => 'page_fields',
    'title'       => '首页配置',
    'description' => '调整首页布局相关的配置项。',
    'fields'      => [
        // 首页自定义块
        [
            'type'    => 'subheading',
            'content' => '<i class="cxicon cxicon-jtright"></i> 首页轮播模块相关配置',
        ],[
            'id'          => 'home-slide',
            'type'        => 'select',
            'title'       => '顶部轮播模块样式',
            'options'     => [
                'one'       => '轮播+今日推荐',  
                'none'      => '隐藏',
            ],
            'default'     => 'one'
        ],[
            'id'      => 'home-slide-number',
            'type'    => 'spinner',
            'title'   => '调用轮播图数量',
            'min'     => 1,
            'max'     => 5,
            'step'    => 1,
            'default' => 3,
            'dependency' => ['home-slide', '==', 'one']
        ],

        // 首页自定义块
        [
            'type'    => 'subheading',
            'content' => '<i class="cxicon cxicon-jtright"></i> 首页自定义推荐模块相关配置',
        ],[
            'id'      => 'home-custom', 
            'type'    => 'switcher',
            'title'   => '首页自定义推荐模块',
            'desc'    => '开启后可DIY显示内容！',
            'default' => true
        ],[
            'id'     => 'home-customdata',
            'type'   => 'group',
            'title'  => '显示内容管理',
            'button_title' => '添加新内容',
            'fields' => [
                [
                    'id'    => 'title',
                    'type'  => 'text',
                    'title' => '标题'
                ],[
                    'id'    => 'desc',
                    'type'  => 'text',
                    'title' => '模块内容描述',
                    'attributes' => [
                        'style'  => 'width: 100%;max-width: 600px'
                    ]
                ],[
                    'id'      => 'image', 
                    'type'    => 'upload',
                    'title'   => '显示图片',
                    'library' => 'image',
                    'preview' => true
                ],[
                    'id'      => 'imagetype',
                    'type'        => 'select',
                    'title'       => '选择图片显示方式',
                    'options'     => [
                        'fillet'    => '圆角显示',
                        'round'     => '圆形显示',  
                        'none'      => '直角显示',
                    ],
                    'default' => 'fillet'
                ],[
                    'id'    => 'url',
                    'type'  => 'text',
                    'title' => '跳转链接',
                    'placeholder' => 'http://'
                ],[
                    'id'      => 'target',
                    'type'    => 'switcher',
                    'title'   => '新窗口打开',
                    'default' => false
                ]
            ],
            'default' => [
                [
                    'title'     => '测试内容一',
                    'desc'      => '再测试一下描述信息显描述信息',
                    'target'    => true,
                    'url'       => 'https://www.chenxingweb.com',
                    'imagetype' => 'fillet',
                    'image'     => cx_assetsurl('icon-1.svg',false)
                ],[
                    'title'     => '测试内容二',
                    'desc'      => '再测试一下描述信息显描述信息',
                    'target'    => true,
                    'url'       => 'https://www.chenxingweb.com',
                    'imagetype' => 'fillet',
                    'image'     => cx_assetsurl('icon-2.svg',false)
                ],[
                    'title'     => '测试内容三',
                    'desc'      => '再测试一下描述信息显描述信息',
                    'target'    => true,
                    'url'       => 'https://www.chenxingweb.com',
                    'imagetype' => 'fillet',
                    'image'     => cx_assetsurl('icon-3.svg',false)
                ],[
                    'title'     => '测试内容四',
                    'desc'      => '再测试一下描述信息显描述信息',
                    'target'    => true,
                    'url'       => 'https://www.chenxingweb.com',
                    'imagetype' => 'fillet',
                    'image'     => cx_assetsurl('icon-4.svg',false)
                ]
            ],
            'dependency' => ['home-custom', '==', 'true']
        ],

        // 热点推荐模块
        [
            'type'    => 'subheading',
            'content' => '<i class="cxicon cxicon-jtright"></i> 首页热点推荐模块相关配置',
        ],[
            'id'      => 'home-press', 
            'type'    => 'switcher',
            'title'   => '首页热点推荐模块',
            'desc'    => '开启后发布文章时可推送文章显示到该模块中！',
            'default' => true
        ],[
            'id'      => 'home-press-desc',
            'type'    => 'text',
            'title'   => '模块说明',
            'default' => '为您推荐热点资讯！',
            'dependency' => ['home-press', '==', 'true']
        ],[
            'id'          => 'home-press-right',
            'type'        => 'select',
            'title'       => '选择标题右侧显示',
            'options'     => [
                'color'     => '色块',
                //'hyh'       => '换一批按钮',  
                'none'      => '不显示',
            ],
            'default'     => 'color',
            'dependency' => ['home-press', '==', 'true']
        ]
    ]
]);

// 站点底部配置项
CSF::createSection( $prefix, [
    'parent'      => 'page_fields',
    'title'       => '底部配置',
    'description' => '调整网站基本功能配置项。',
    'fields'      => [
        [
            'id'      => 'foot-nav', 
            'type'    => 'switcher',
            'title'   => '底部菜单显示',
            'default' => true
        ],[
            'id'     => 'foot-navdata',
            'type'   => 'group',
            'title'  => '底部菜单管理',
            'button_title' => '添加新项目',
            'fields' => [
                [
                    'id'    => 'name',
                    'type'  => 'text',
                    'title' => '链接名称'
                ],[
                    'id'    => 'url',
                    'type'  => 'text',
                    'title' => '跳转链接',
                    //'attributes' => [
                        //'style'  => 'width: 100%;'
                    //],
                    'placeholder' => 'http://'
                ],[
                    'id'      => 'target',
                    'type'    => 'switcher',
                    'title'   => '新窗口打开',
                    'default' => false
                ]
            ],
            'default' => [
                [
                    'name'   => '晨星博客',
                    'target' => true,
                    'url'    => 'https://www.chenxingweb.com'
                ],[
                    'name'   => '百度一下',
                    'target' => true,
                    'url'    => 'https://www.baidu.com'
                ],[
                    'name'   => '阿里云',
                    'target' => true,
                    'url'    => 'https://www.aliyun.com'
                ]
            ],
            'dependency' => ['foot-nav', '==', 'true']
        ],[
            'id'          => 'foot-desc',
            'type'        => 'textarea',
            'title'       => '网站底部说明',            
            'default'     => '免责声明：本网站部分内容由用户自行上传，如权利人发现存在误传其作品情形，请及时与本站联系。',
            'attributes'  => [
                'style'   => 'min-height:30px;height:70px;line-height:30px;margin-bottom:0px'
            ]
        ],[
            'id'          => 'foot-icp',
            'type'        => 'text',
            'title'       => 'ICP备案号',            
            'default'     => '京ICP备19013858号-1'
        ],[
            'id'          => 'foot-ga',
            'type'        => 'text',
            'title'       => '公安备案号',            
            'default'     => '京公网安备11000002000001号'
        ]
    ]
]);


//
// Field: textarea
//
CSF::createSection( $prefix, array(
    'title'       => 'SEO配置',
    'icon'        => 'cxicon cxicon-seo',
    'description' => '调整网站SEO相关功能配置项。',
    'fields'      => array(
  
      array(
          'id'      => 'seo-off',
          'type'    => 'switcher',
          'title'   => '开启主题SEO功能',
          'label'   => '如果您用的有插件，可能会引起冲突，可以关闭主题的SEO功能！',
          'default' => true,
      ),
  
      array(
          'id'     => 'seo-data',
          'type'   => 'fieldset',
          'fields' => array(
              array(
                  'id'         => 'title',
                  'type'       => 'text',
                  'title'      => '网站标题',
                  'desc'       => '填写网站Title标题',
                  'attributes' => array(
                      'style'  => 'width: 100%;',
                  ),
                  'default'    => '晨星博客主题默认Title，可到主题配置面板SEO配置中修改！',
              ),
              array(
                  'id'         => 'keywords',
                  'type'       => 'text',
                  'title'      => '网站关键词',
                  'desc'       => '3-5个关键词，用英文逗号隔开',
                  'attributes' => array(
                      'style' => 'width: 100%;',
                  ),
                  'default'    => '晨星博客,chenxingweb.com,晨星原创主题',
              ),
              array(
                  'id'      => 'description',
                  'type'    => 'textarea',
                  'title'   => '网站描述',
                  'default' => '晨星博客（ChenXingWeb.Com）专注WordPress程序周边主题及插件的开发制作，旨在为大家提供优质主题资源和服务，解决广大站长的建站需求。',
              ),
              array(
                  'id'      => 'connector',
                  'type'    => 'text',
                  'title'   => '全站链接符',
                  'desc'    => '一经选择，切勿更改，对SEO不友好，一般为“-”或“_”',
                  'default' => '-',
              ),
          ),
          'dependency' => array('seo-off', '==', 'true'),
      ),
      
      array(
          'id'      => 'basic-nocategoty',
          'type'    => 'switcher',
          'title'   => '分类去除category/前缀',
          'label'   => '如果使用了同类功能的插件请关闭该项！',
          'default' => false,
      ),    
  
    )
  ) );

// 网站优化类
CSF::createSection( $prefix,[
    'id'          => 'optimize',
    'title'       => '网站优化',
    'icon'        => 'cxicon cxicon-youhua',
    'description' => '通过关闭一些您不需要的功能来优化网站性能！',
]);
CSF::createSection( $prefix, [
    'parent'      => 'optimize',
    'title'       => '常规优化',
    'description' => '控制一些常用的优化项目的使用状况！',
    'fields'      => [
        [
            'id'      => 'optimize-json',
            'type'    => 'switcher',
            'title'   => '移除wp-json链接',
            'label'   => '开启之后head标签中将不再显示wp-json链接！',
            'default' => true,
        ],[
            'id'      => 'optimize-emoji',
            'type'    => 'switcher',
            'title'   => '移除emoji脚本',
            'label'   => '开启之后head标签中将不再显示emoji相关的脚本和样式！',
            'default' => true,
        ],[
            'id'      => 'optimize-head',
            'type'    => 'switcher',
            'title'   => '移除头部冗余代码',
            'label'   => '开启之后将对head中的冗余标签进行清理！',
            'default' => true,
        ],[
            'id'      => 'optimize-embeds',
            'type'    => 'switcher',
            'title'   => '禁用embeds功能',
            'label'   => '开启之后将禁用embeds功能，页面底部不再加载embeds.min.js脚本！',
            'default' => true,
        ],[
            'id'      => 'optimize-google',
            'type'    => 'switcher',
            'title'   => '禁用谷歌字体',
            'label'   => '开启之后将禁用谷歌字体！',
            'default' => true,
        ],[
            'id'      => 'optimize-styles',
            'type'    => 'switcher',
            'title'   => '禁止加载 global-styles-inline-css',
            'label'   => '前台禁止加载 global-styles-inline-css 样式文件，使用古腾堡编辑器自定义样式如果前台不生效可以关闭改功能！',
            'default' => false,
        ],[
            'id'      => 'optimize-prefetch',
            'type'    => 'switcher',
            'title'   => '移除 dns-prefetch 标签',
            'label'   => 'dns-prefetch标签显示在Head中作用为DNS预解析，建议保留！',
            'default' => false,
        ],[
            'id'      => 'optimize-headsvg',
            'type'    => 'switcher',
            'title'   => '移除 Head中加载的SVG相关的css代码',
            'label'   => '禁用可能引起前台跟后台样式不同或者后台部分设置项无效！',
            'default' => false,
        ]
    ]
]);