var registerPlugin = wp.plugins.registerPlugin;
var PluginDocumentSettingPanel = wp.editPost.PluginDocumentSettingPanel;
var ToggleControl = wp.components.ToggleControl;
var useState = wp.element.useState;
var useDispatch = wp.data.useDispatch;
var select = wp.data.select;
var __ = wp.i18n.__;

var RecommendDocumentPanel = function () {
    var dispatch = useDispatch();
    var getEditedPostAttribute = select('core/editor').getEditedPostAttribute;
    const postType = select('core/editor').getCurrentPostType();
    if( postType != 'post' ) return false;
    var postId   = getEditedPostAttribute('id'); 
    var postMeta = getEditedPostAttribute('meta');
    if( !postId ) return false;
    var _useState = useState(postMeta._recommend),
        recommendField = _useState[0],
        setRecommendField = _useState[1];

    var _useState2 = useState(postMeta._marked),
        markedField = _useState2[0],
        setMarkedField = _useState2[1];

    var recommendChange = function (value) {
        setRecommendField(value);
        dispatch('core/editor').editPost({ meta: { '_recommend': value } });
    };

    var markedChange = function (value) {
        setMarkedField(value);
        dispatch('core/editor').editPost({ meta: { '_marked': value } });
    };

    return React.createElement(PluginDocumentSettingPanel, {
        name: "article-recommendation",
        title: __('文章推荐','Meteor'),
        className: "article-recommendation"
    }, 
    React.createElement("p", {
        className: "description-text",
        style: { 
            fontSize: '12px',
            background: '#d3f5d4',
            padding: '0 10px',
            lineHeight: '26px',
            textAlign: 'center',
            borderRadius: '4px',
            color: '#0f6702'
        } 
    }, __('将文章推送至指定位置显示。','Meteor')),
    React.createElement("hr", null), 
    React.createElement(ToggleControl, {
        label: __('推送至首页推荐模块','Meteor'),
        checked: recommendField,
        onChange: recommendChange
    }),
    //React.createElement("p", null, __('通过该按钮可让当前文章推送至指定模块显示。','Meteor')),
    React.createElement("hr", null),    
    React.createElement(ToggleControl, {
        label: __('推送至首页轮播模块','Meteor'),
        checked: markedField,
        onChange: markedChange
    }));
};

// 注册插件
registerPlugin('article-recommendation-panel', {
    render: RecommendDocumentPanel
});