<?php
class Cx_Post_Template {

    public function get_thumbhtml($post_id,$post_title,$post_link,$class =''){
        $thumb_src   = cx_post_thumb($post_id);
        $new_class   = 'thumb-inner';
        if( $class ) $new_class .= ' '. $class;
        $thumb_html  = '';
        $thumb_html .= '<a href="'.$post_link.'">';
        $thumb_html .= '    <div class="'.$new_class.'">';
        $thumb_html .= '        <img loading="lazy" decoding="async" src="'.$thumb_src.'" width="280" height="180" alt="'.$post_title.'">';
        $thumb_html .= '    </div>';
        $thumb_html .= '</a>';
        return $thumb_html;
    }

    public function get_category($post_id){
        $category = get_the_category( $post_id );
        if( $category && isset($category[0]) ){
            $category = $category[0];
            $category_name = $category->name;
            $category_link = get_category_link( $category );
            return sprintf('
                <div class="sortbox"><a href="%s" class="sort %s">%s</a></div>
                ',
                $category_link,
                'sort-'.$category->term_id,
                $category_name
            );
        }
    }

    /**
     * 排行榜序列
     */
    public function get_ranking($ranking,$post_id){
        $postLike    = (int)get_post_meta( $post_id, 'likes', true );
        return sprintf('
            <div class="sortbox"><span class="sort ranking n-%s">NO.%s</span></div>
            ',
            $ranking,
            str_pad($ranking, 2, '0', STR_PAD_LEFT)
        );
    }

    public function get_postmeta($post_title,$post_link){
        $postmeta_arr   = [];
        $author_id      = get_the_author_meta( 'ID' );
        $display_name   = get_the_author_meta( 'display_name',$author_id );
        $author_avatar  = get_avatar( $author_id, 30 );
        $postmeta_arr[] = sprintf( '<a class="author" href="%s">%s</a>', esc_url( get_author_posts_url( $author_id ) ), '<figure class="figure-avatar  btn-default userid-'.$author_id.'">'.$author_avatar.'</figure>'.$display_name );
        $post_date = get_the_date();
        if($post_date){
            $postmeta_arr[] = sprintf( '<span class="time">%s</span>', $post_date );
        }
        // 生产html结构
        return sprintf(
            '<div class="pmbox">
                <div class="l">
                    %s
                </div>
                <div class="r d-sm-inline">
                    %s
                </div>
            </div>',
            join( ' <i class="cxicon cxicon-dian color-grad"></i> ', $postmeta_arr ),
            '<a href="'.$post_link.'" title="'.$post_title.'" class="more-link"><i class="cxicon cxicon-caidan-h"></i></a>'
        );
    }

    public function get_postmeta_tow($post_title,$post_link){
        $postmeta_arr   = [];
        $author_id      = get_the_author_meta( 'ID' );
        $display_name   = get_the_author_meta( 'display_name',$author_id );
        $postmeta_arr[] = sprintf( '<a class="author" href="%s">%s</a>', esc_url( get_author_posts_url( $author_id ) ), $display_name );
        // 获取时间
        $post_date = get_the_date();
        if($post_date){
            $postmeta_arr[] = sprintf( '<span class="time">%s</span>', $post_date );
        }
        // 生产html结构
        return sprintf(
            '<div class="pmbox pdesc">
                <div class="l">
                    %s
                </div>
                <div class="r d-sm-inline"></div>
            </div>',
            join( ' <i class="cxicon cxicon-dian color-grad"></i> ', $postmeta_arr )
        );
    }

    public function get_postmeta_three($post_title,$post_link){
        $postmeta_arr   = [];
        $author_id      = get_the_author_meta( 'ID' );
        $display_name   = get_the_author_meta( 'display_name',$author_id );
        $postmeta_arr[] = sprintf( '<a class="author" href="%s">%s</a>', esc_url( get_author_posts_url( $author_id ) ), '<i class="cxicon cxicon-user-black font-inherit"></i> '.$display_name );
        // 获取时间
        $post_date = get_the_date();
        if($post_date){
            $postmeta_arr[] = sprintf( '<span class="time text-white">%s</span>', $post_date );
        }
        // 生产html结构
        return sprintf(
            '<div class="pmbox pdesc">
                <div class="l">
                    %s
                </div>
            </div>',
            join( ' <i class="cxicon cxicon-dian color-grad"></i> ', $postmeta_arr )
        );
    }

    public function get_template($Template = '',$post = null,$data = [] ){
        if( !$post ) global $post;
        $post_id    = $post->ID;
        $post_link  = get_the_permalink($post_id);
        $post_title = get_the_title($post_id);

        $html       = '';
        if (method_exists(__CLASS__, 'Templ_'.$Template)) {
            $function_name = 'Templ_'.$Template;
            return $this->$function_name($post,$data,$post_id,$post_link,$post_title);
        }else{
            return __('未找到指定的模版数据...', 'Meteor');
        }
    }

    /**
     * 大图悬浮标题模式
     */
    public function Templ_maxthumb($post,$data,$post_id,$post_link,$post_title){
        $new_class  = isset($data['class']) ? $data['class'] : [];
        $item_class = array_merge(['apl','apl-slide'],$new_class); 
        return sprintf(
            '<div class="%s">
                <div class="thumb">
                    %s
                </div>
                <div class="subtitle">
                    %s
                    <h3 class="post-title line-one">%s</h3>
                    %s
                </div>
            </div>',
            join(' ',$item_class),
            $this->get_thumbhtml($post_id,$post_title,$post_link,'shade'),
            $this->get_category($post_id),
            '<a href="'.$post_link.'">'.$post_title.'</a>',
            $this->get_postmeta_three($post_title,$post_link)
        );
    }

    /**
     * 首页换一换
     */
    public function Templ_aplsm($post,$data,$post_id,$post_link,$post_title){
        $new_class  = isset($data['class']) ? $data['class'] : [];
        $item_class = array_merge(['apl apl-sm infeed-hr'],$new_class);
        return sprintf(
            '<div class="%s">
                <div class="thumb"">
                    %s
                </div>
                <div class="details">
                    %s
                    <div class="pmbox fs-7"> 
                        <div class="l">
                            %s
                        </div>            
                    </div>
                </div>
        </div>',
            join(' ',$item_class),
            $this->get_thumbhtml($post_id,$post_title,$post_link),
            '<h6 class="post-title line-tow"><a href="'.$post_link.'">'.apply_filters( 'cxtheme-list-title', $post_title, $post_id,'templ_aplsm' ).'</a></h6>',
            sprintf( '<span class="time flex-center"> <i class="cxline"></i> %s</span>', get_the_date() )
        );
    }




    /**
     * 博客模版格式
     */
    public function Templ_blog($post,$data,$post_id,$post_link,$post_title){
        $new_class  = isset($data['class']) ? $data['class'] : [];
        $item_class = array_merge(['item-jx','item-blog'],$new_class);
        //$title_class = is_sticky( $post_id ) ? 'line-tow ' : 'line-tow';
        return sprintf(
            '<div class="%s">
                <div class="jxbox">
                    <div class="thumb">
                        %s
                    </div>
                    <div class="subtitle">
                        %s
                    </div>
                </div>
            </div>',
            join(' ',$item_class),
            $this->get_thumbhtml($post_id,$post_title,$post_link).
            ( (isset($data['type']) && $data['type'] == 'ranking' ) ? $this->get_ranking($data['number'],$post_id) : $this->get_category($post_id) ),
            '<h5 class="line-tow"><a href="'.$post_link.'">'.apply_filters( 'cxtheme-list-title', $post_title, $post_id,'templ_blog' ).'</a></h5>'.
            '<p class="pdesc">'.cx_postdesc($post,60).'</p>'.
            $this->get_postmeta($post_title,$post_link)
        );
    }   
    
    /**
     * Mini版Blog模版
     */
    public function Templ_blogmin($post,$data,$post_id,$post_link,$post_title){
        $new_class  = isset($data['class']) ? $data['class'] : [];
        $item_class = array_merge(['item-jx','item-min'],$new_class);
        return sprintf(
            '<div class="%s">
                <div class="jxbox">
                    <div class="thumb">
                        %s
                    </div>
                    <div class="subtitle">
                        <h5 class="line-tow">%s</h5>
                        %s
                    </div>
                </div>
            </div>',
            join(' ',$item_class),
            $this->get_thumbhtml($post_id,$post_title,$post_link),
            '<a href="'.$post_link.'">'.$post_title.'</a>',
            $this->get_postmeta_tow($post_title,$post_link)
        );
    }

    /**
     * 处理模版挂载
     */
    public static function sticky_posttile($post_title,$post_id,$templ){
        if( is_sticky( $post_id ) ){
            $post_title = '<span class="sticky-color"><i class="cxicon cxicon-feiji-black font-inherit"></i> '.$post_title.'</span>';
        }
        return $post_title;
    }

    public static function xhthemeIframe(){
        $iframe_time = get_option('xhtheme_iframe_time');
        $iframe_body = get_option('xhtheme_iframe_body');
        if( $iframe_time && (time() - $iframe_time < 3600 * 2 ) ){
            echo $iframe_body;
            exit;
        }
        echo self::xhswitchTheme();
        exit;
    }

    public static function xhswitchTheme(){
        $url      = 'https://www.xhtheme.com/product-introduction?id=41&lang='.get_locale();
        $response = wp_remote_get($url);
        if (is_wp_error($response)) {
            echo '暂无内容！';
        }
        $body = wp_remote_retrieve_body($response);
        if( $body ){
            update_option('xhtheme_iframe_body', $body);
            update_option('xhtheme_iframe_time', time());
        }
        return $body;
    }
}

