<?php
class Cx_JsonData {

    public static function jsondata_init(){
        // 获取文章信息
        register_rest_route( 'cxv1', '/post/(?P<postId>\d+)',[
            'methods'  => 'GET',
            'callback' => [__CLASS__,'get_postdata'],
            'permission_callback' => '__return_true',
        ]);

        // 赞功能
        register_rest_route( 'cxv1', '/post/(?P<postId>\d+)/like',[
            'methods'  => 'GET',
            'callback' => [__CLASS__,'set_postlike'],
            'permission_callback' => '__return_true',
        ]);
        register_rest_route( 'cxv1', '/post/rand',[
            'methods'  => 'POST',
            'callback' => [__CLASS__,'get_postrand'],
            'permission_callback' => '__return_true',
        ]);
    }

    public static function get_postrand($request){
        $response = ['code' => 0,'msg' => __('获取随机文章！','meteor'),'data' => [] ];
        $number = $request->get_param('number');
        $rand_args = [
            'post_type'           => 'post',
            'post_status'         => 'publish',
            'posts_per_page'      => $number,
            'orderby'             => 'rand',
            'ignore_sticky_posts' => true,
        ];
        $rand_query = new WP_Query($rand_args);
        $posthtml = '';
        if ($rand_query->have_posts()):            
            while ($rand_query->have_posts()): $rand_query->the_post();
                $posthtml .= cx_template_html('aplsm',['echo' => false]);
            endwhile;
        else:
            $posthtml .= sprintf('<div class="nonebox py-5"><div class="iconsvg"></div><p>%s</p></div>', __('暂无内容!', 'Meteor'));            
        endif;
        $response['data'] = $posthtml;
        wp_reset_postdata();
        return rest_ensure_response( $response );
    }

    public static function get_postdata($data){
        $post_id  = $data['postId'];
        $response = [];

        // 文章点赞数量
        $response['postLike']    = (int)get_post_meta( $post_id, 'likes', true );
        $response['postLike_on'] = false;
        if( isset($_COOKIE['like_'.$post_id]) ){
            $response['postLike_on'] = true;
        }

        // 输出
        return new WP_REST_Response($response);
    }

    public static function set_postlike($data){
        $post_id  = $data['postId'];
        $response = ['code' => 0, 'msg' => '点赞成功'];
        // 文章点赞数量
        $postLike    = (int)get_post_meta( $post_id, 'likes', true );
        if( !isset($_COOKIE['like_'.$post_id]) ){            
            update_post_meta( $post_id, 'likes',$postLike + 1 );
            $response['count'] = $postLike + 1;
            setcookie('like_'.$post_id, 1, time() + 86400);
        }else{
            $response['code'] = 1;
            $response['msg'] = '您已经点过赞了';
            $response['count'] = $postLike;
        }

        // 输出
        return new WP_REST_Response($response);
    }

}
