<!doctype html>
<html <?php language_attributes();?>>

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <?php wp_head(); ?>
</head>

<body <?php body_class(); ?> x-data="MeteorData" :data-bs-theme="darkMode ? 'dark' : ''" :class="{'dark': darkMode,'overflow-y-hidden':popBgshow || searchPopup}">
    <div class="site-wrapper">
        <header class="header-s1" :class="{'onfixed' : searchPopup}">
            <div class="headnav">
                <div class="container-xl h-container">
                    <div class="cxlogo">
                        <?php
                        $logoImage = cx_option('site-logo',cx_assetsurl('logo.png',false));
                        $logodark  = cx_option('site-logo-dark',$logoImage);
                        ?>
                        <a href="<?php echo home_url();?>">
                            <img src="<?php echo $logoImage;?>" alt="<?php bloginfo();?>" class="c-light" :src="darkMode ? '<?php echo $logodark;?>' : '<?php echo $logoImage;?>'" width="120" height="60"/>                         
                        </a>
                    </div>
                    <nav class="head-menu d-lg-flex">
                        <ul id="menu-main-menu" class="navbar-nav">
                        <?php 
                        if(function_exists('wp_nav_menu')){
                            wp_nav_menu([
                                'container'      => false,
                                'items_wrap'     => '%3$s',
                                'theme_location' => 'header-nav',
                                'fallback_cb'    => 'cx_menu_fallback'
                            ]);
                        }
                        ?>
                        </ul>
                    </nav>
                    <div class="header-r">
                        <ul class="h-btnbox sm-cnone">
                            <li class="list-inline-item">
                                <a href="<?php echo cx_templurl('page-live.php');?>">
                                    <i class="cxicon cxicon-ranking"></i>
                                </a>
                            </li>
                            <li class="list-inline-item">
                                <a href="javascript:;" @click="darkMode = !darkMode;localStorage.setItem('darkMode', darkMode);">
                                    <i class="cxicon cxicon-sunlight" :class="{'d-none':darkMode}"></i>
                                    <i class="cxicon cxicon-moon" :class="{'d-none':!darkMode}"></i>
                                </a>
                            </li>
                        </ul>
                        <div class="h-buttons">
                            <button type="button" class="search btn-default icon-button" @click="searchPopup = !searchPopup" title="Search Btn">
                                <i class="cxicon cxicon-search font-inherit" :class=" searchPopup ? 'cxicon-error' : 'cxicon-search'"></i>
                            </button>
                            <!-- 移动端菜单 -->
                            <button type="button" class="search btn-default icon-button" @click="moibleMenu = popBgshow = true" title="Menu Btn">
                                <i class="cxicon cxicon-menu3 font-inherit"></i>
                            </button>
                        </div>
                    </div>

                </div>
            </div>            
        </header><!-- header.end-->
        <!-- Moible Nav -->
        <div class="mobile-navbox trans_2ms" :class="{'visible': moibleMenu}">
            <button type="button" class="btn-close" aria-label="关闭" @click="popBgshow = moibleMenu = false"></button>
            <div class="m-menulogo p-4 pt-3"></div>
            <div class="m-navbox p-4 pt-0">
                <ul id="moible-menu" class="m-nav pe-4">
                <?php 
                if(function_exists('wp_nav_menu')){
                    wp_nav_menu([
                        'container'      => false,
                        'items_wrap'     => '%3$s',
                        'theme_location' => 'moible-nav',
                        'fallback_cb'    => 'cx_menu_fallback_left'
                    ]);
                }
                ?>
                </ul>
            </div>
        </div>
        <!-- MN.end -->
        

        <main class="main-container" role="main">