<?php
/***************************************
## Theme URI: https://www.chenxingweb.com/wordpress-theme-cx-multi.html
## Author: 晨星博客
## Author URI: https://www.chenxingweb.com
## Description: 简洁时尚自适应博客杂志类主题，有问题请加QQ群597157500请求帮助。
## Theme Name: CX-MULTI
## Version: 1.0
****************************************/

function cx_global_option() {
    global $cx_option, $cxkz_option;
    $cx_option   = get_option( MD5(CX_THEMES_NAME) );
    $cxkz_option = get_option( MD5(CX_THEMES_NAME.'_extend') );
}
call_user_func('cx_global_option');

// 适配 wp_body_open 函数
if (!function_exists('wp_body_open')) :
    function wp_body_open(){
        do_action( 'wp_body_open' );
    }
endif;


// 获取当前页面url
if (!function_exists('cx_currenturl')) :
    function cx_currenturl() {
        $ssl = (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') ? true : false;
        $sp = strtolower($_SERVER['SERVER_PROTOCOL']);
        $protocol = substr($sp, 0, strpos($sp, '/')) . (($ssl) ? 's' : '');
        $host = isset($_SERVER['HTTP_X_FORWARDED_HOST']) ? $_SERVER['HTTP_X_FORWARDED_HOST'] : (isset($_SERVER['HTTP_HOST']) ? $_SERVER['HTTP_HOST'] : $_SERVER['SERVER_NAME']);
        return $protocol . '://' . $host . $_SERVER['REQUEST_URI'];
    }
endif;

// 组装附件url
if( !function_exists('cx_assetsurl')):
    function cx_assetsurl($assetsname = '',$echo = true ){
        $file_url = get_theme_file_uri('assets/images/'.$assetsname);
        if( !$echo ){
            return $file_url;
        }
        echo $file_url; 
    }
endif;

// 获取主题参数
if (!function_exists('cx_option')) :
    function cx_option($optname = '', $default = false,$option = null){
        global $cx_option;
        $cxoption = $option && is_array($option) ? $option : $cx_option;
        return ($cxoption && isset($cxoption[$optname])) ? $cxoption[$optname] : $default;
    }
endif;

// 开关调用
if (!function_exists('cx_switcher')) :
    function cx_switcher($optname = '',$default = false,$option = null){
        global $cx_option;
        $cxoption = $option ? $option : $cx_option;
        return ($cxoption && isset($cxoption[$optname])) ? (bool)$cxoption[$optname] : $default;
    }
endif;

// 获取扩展参数
if (!function_exists('cxkz_option')) :
    function cxkz_option($optname = '', $default = false,$option = null){
        global $cxkz_option;
        $cxoption = $option && is_array($option) ? $option : $cxkz_option;
        return ($cxoption && isset($cxoption[$optname])) ? $cxoption[$optname] : $default;
    }
endif;

// 扩展开关调用
if (!function_exists('cxkz_switcher')) :
    function cxkz_switcher($optname = '',$default = false,$option = null){
        global $cxkz_option;
        $cxoption = $option? $option : $cxkz_option;
        return ($cxoption && isset($cxoption[$optname])) ? (bool)$cxoption[$optname] : $default;
    }
endif;

// 数组为空判断
if( !function_exists('cx_arrempty')):
    function cx_arrempay( array $arr,$str = ''){
        if( isset($arr[$str]) && !empty($arr[$str]) ) return true;
        return false;
    }
endif;

// 获取页面url
if (!function_exists('cx_pageurl')) :
    function cx_pageurl($name = ''){
        if( !is_numeric($name) ){
            global $wpdb;
            $page_id = $wpdb->get_var(
                $wpdb->prepare(
                    "SELECT ID FROM $wpdb->posts WHERE post_name = %s",
                    $name
                )
            );
        } else {
            $page_id = $name;
        }       
        return get_permalink($page_id);
    }
endif;

// 获取页面url
if (!function_exists('cx_templurl')) :
    function cx_templurl($template,$type = 'link'){
        global $wpdb;
        $page_id = $wpdb->get_var($wpdb->prepare("SELECT `post_id` FROM `$wpdb->postmeta`, `$wpdb->posts` WHERE `post_id` = `ID` AND `post_status` = 'publish' AND `meta_key` = '_wp_page_template' AND `meta_value` = %s LIMIT 1;", $template));
        return $type == 'link' ? get_permalink($page_id) : $page_id;
    }
endif;


// 获取用户IP
if (!function_exists('cx_getuserip')) :
    function cx_getuserip() {
        $user_ip = $_SERVER['REMOTE_ADDR'];
        if (isset($_SERVER['HTTP_CLIENT_IP']) && preg_match('/^([0-9]{1,3}\.){3}[0-9]{1,3}$/', $_SERVER['HTTP_CLIENT_IP'])) {
            $user_ip = $_SERVER['HTTP_CLIENT_IP'];
        } elseif(isset($_SERVER['HTTP_X_FORWARDED_FOR']) AND preg_match_all('#\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}#s', $_SERVER['HTTP_X_FORWARDED_FOR'], $matches)) {
            foreach ($matches[0] AS $xip) {
                if (!preg_match('#^(10|172\.16|192\.168)\.#', $xip)) {
                    $user_ip = $xip;
                    break;
                }
            }
        }
        return $user_ip;
    }
endif;

// 本周更新文章数量
if (!function_exists('cx_update_postnum')) :
    function cx_update_postnum($type = '',$cat = null) {
        $date_query = array(
            array(
                'after' =>  $type ? $type : '1 month ago' // 1 week ago
            )
        );
        $args = array(
            'post_type'        => 'post',
            'post_status'      => 'publish',
            'date_query'       => $date_query,
            'no_found_rows'    => true,
            'suppress_filters' => true,
            'fields'           => 'ids',
            'posts_per_page'   => - 1
        );
        if( $cat ){
            $args['cat'] = $cat;
        }
        $query = new WP_Query($args);
        return (int)$query->post_count;
    }
endif;


// 输出缩略图地址
if (!function_exists('cx_post_thumb')) :
    function cx_post_thumb($post_id = 0,$default = '') {
        if(empty($post_id)){
            global $post;
            $post_id = $post->ID;
        }
        $thumbnail_src   = apply_filters('post_thumbnail', '', $post_id, $default);
        if( $thumbnail_src ) return $thumbnail_src;
        if($post_img_src = get_post_meta($post_id, 'thumb_src', true)){
            $thumbnail_src = $post_img_src;
        }elseif (has_post_thumbnail($post_id)) {
            $thumbnail_src = wp_get_attachment_image_src(get_post_thumbnail_id($post_id) , 'full');
            $thumbnail_src = $thumbnail_src[0];
        } else {
            $posts  = get_post($post_id);        
            $output = preg_match_all('/<img.*?(?: |\\t|\\r|\\n)?src=[\'"]?(.+?)[\'"]?(?:(?: |\\t|\\r|\\n)+.*?)?>/sim', $posts->post_content, $matches);
            if (!empty($matches[1][0])) {
                $thumbnail_src = $matches[1][0];
            } else {
                $thumbnail_src = $default ? $default : cx_option('_defimages'); // 文章没有图片时调用的默认图片
            }
        }
        if( !$thumbnail_src ){
            $thumbnail_src = get_theme_file_uri( 'assets/images/nothumb.png' );
        }
        return $thumbnail_src;
    }
endif;

// 输出term缩略图地址
if (!function_exists('get_term_thumb')) :
    function get_term_thumb($term_id){
        $term_thumb   = '';
        $cxterm_image = get_term_meta( $term_id,'cxterm-image', true );
        if( $cxterm_image ){
            $term_thumb = $cxterm_image;
        }else{
            // 从文章中获取图片
        }
        return apply_filters( 'cxtheme-termthumb-data', $term_thumb, $term_id);
    }
endif;

// 时间格式显示N天前
if (!function_exists('cx_timeago')) :
    function cx_timeago($ptime) {
        if(!is_int($ptime)) $ptime = strtotime($ptime);    
        $etime = time() - $ptime;
        if ($etime < 1) return '刚刚';
        $interval = array(
            12 * 30 * 24 * 60 * 60 => '年前',
            30 * 24 * 60 * 60 => '个月前',
            7 * 24 * 60 * 60 => '周前',
            24 * 60 * 60 => '天前',
            60 * 60 => '小时前',
            60 => '分钟前',
            1 => '秒前'
        );
        foreach ($interval as $secs => $str) {
            $d = $etime / $secs;
            if ($d >= 1) {
                $r = round($d);
                return $r . $str;
            }
        }
    }
endif;

// 空白提示
if (!function_exists('cx_module_none')) :
    function cx_module_none( $images = '', $text = '没有找到相关数据！',$style = '' ) {
        $images    = $images ? $images : get_theme_file_uri( 'assets/images/module-none.svg' );
        $html_none = sprintf('
            <div class="cxtheme-module-none"%s>
                <p><img src="%s" alt="空数据"></p> 
                <p><span>%s</span></p>
            </div>'
            ,!empty($style) ? ' style="'.$style.'"' : ''
            ,$images
            ,$text
        );
        return $html_none;
    }
endif;

// 调用模版
if (!function_exists('cx_template_html')) :
    function cx_template_html($Template = '',$data = [],$post = null){
        global $Cx_Post_Template;
        if( !$Cx_Post_Template ){
            $Cx_Post_Template = new Cx_Post_Template;
        }
        $defaults = array(
            'before' => '',
            'after'  => '',
            'echo'   => true
        );    
        $newdata = wp_parse_args( $data, $defaults );
        $echo    = $newdata['echo'];
        $before  = $newdata['before'];
        $after   = $newdata['after'];

        unset($newdata['echo']);
        unset($newdata['before']);
        unset($newdata['after']);

        // 组合
        $temple_html   = '';
        $temple_html  .= $before;
        $temple_html  .= $Cx_Post_Template->get_template($Template,$post,$newdata);
        $temple_html  .= $after;
        // 输出
        if( !$echo ) return $temple_html;
        echo $temple_html;   
    }
endif;

// 小工具判断
if (!function_exists('cxis_widget')) :
    function cxis_widget( $callback = '', $sidebar = '' ) {
        if( empty($callback) ) return false;
        $sidebars_widgets = wp_get_sidebars_widgets();
        if( !empty($sidebar) ){
            $sidebars_widgets = $sidebars_widgets[$sidebar];
        }
        if( !empty($sidebars_widgets) && is_array($sidebars_widgets) ){
            foreach ($sidebars_widgets as $widgets) {
                if( is_array($widgets) ) continue;
                $widgets_arr = explode("-", $widgets);
                if( isset($widgets_arr[0]) && $widgets_arr[0] == $callback ) return true;
            }
        }
        return false;
    }
endif;

// 提取顶级分类vs子分类
if (!function_exists('cx_catparent')) :
    function cx_catparent($cat,$type='all'){
        if(!$cat) return false;
        $cat_praent    = array();
        $this_category = get_category($cat);
        if(!is_object($this_category)) return false;

        if( $this_category->category_parent > 0){
            while($this_category->category_parent){
                $this_category = get_category($this_category->category_parent);
            }
        }	
        // 输出顶级分类
        if($type == 'parent') return $this_category;

        // 获取顶级分类下面的二级分类
        $cat_id   = $this_category->term_id;
        $cat_list = get_term_children($cat_id,'category');

        if(!is_wp_error($cat_list) && !empty($cat_list)){
            foreach ($cat_list as $get_cat) {
                $cat_praent[] = get_category($get_cat);
            }
        }
        return ($cat_praent)?$cat_praent:false;
    }
endif;


// 作者总热度
if (!function_exists('cx_author_views')) :
    function cx_author_views($author_id = 0 ,$display = true) {
        global $wpdb;
        if($author_id == 0){
            $sql = "SELECT SUM(meta_value+0) FROM $wpdb->postmeta WHERE meta_key = 'views'";
        }else{
            $sql = "SELECT SUM(meta_value+0) FROM $wpdb->posts left join $wpdb->postmeta on ($wpdb->posts.ID = $wpdb->postmeta.post_id) WHERE meta_key = 'views' AND post_author =$author_id";
        }
        $views = intval($wpdb->get_var($sql));
        if($display) {
            if($views>1000000){
                echo '100万+</br>';
            }else if($views>10000){
                echo round(($views/10000),0).' 万</br>';
            }else if($views>10000){
                echo $views;
            }else{
                echo $views;
            }
        } else {
            return $views;
        }
    }
endif;

// 生成Token
if (!function_exists('cx_updatetoken')) :
    function cx_updatetoken() {
        $user_id = (int)get_current_user_id();
        return wp_create_nonce( MD5(DB_PASSWORD).'-'.$user_id );
    }
endif;

// 验证Token
if (!function_exists('cx_verifytoken')) :
    function cx_verifytoken($token) {
        $user_id = (int)get_current_user_id();
        return wp_verify_nonce( $token, MD5(DB_PASSWORD).'-'.$user_id );
    }
endif;

// 过滤参数
if (!function_exists('cx_datafilter')) :
    function cx_datafilter($data,$arr){
        $return = array();
        foreach ($data as $key => $value) {
            if( in_array($key,$arr) ){
                $return[$key] = $value;
            }
        }
        return $return;
    }
endif;

// 生成调试记录
if (!function_exists('cx_addbuglog')) :
    function cx_addbuglog($title = '',$content = null,$logfile = ''){
        //if(  ) return;
        if( empty($logfile) ) $logfile = get_theme_file_path('/theme-bug.log');
        $fp = @fopen($logfile, "a+");
        @fwrite($fp, '['.date("Y-m-d H:i:s").'] '.$title. "\r\n");
        if( !empty($content) ){
            @fwrite($fp, var_export($content, true) . "\r\n");
        }        
        @fclose($fp);
    }
endif;




// 获取文章中图片数量
if (!function_exists('cx_imgtotal')) :
    function cx_imgtotal($post) {
        if( !is_object($post) ) $post = get_post($post);
        preg_match_all('/<img/is ', $post->post_content, $matches, PREG_SET_ORDER);
        return count($matches);
    }
endif;

// 获取文章描述
if (!function_exists('cx_postdesc')) :
    function cx_postdesc($post = '',$length = 200) {
        if(empty($post) ) global $post;
        if( !is_object($post) ) $post = get_post( $post );
        $post_txt = get_post_meta($post->ID,'_post_txt',true);
		if( !empty($post_txt) ){
			$desc = $post_txt;
        }elseif( !empty($post->post_excerpt) ){
            $desc = $post->post_excerpt;
		}else{
			$desc = trim(strip_tags( strip_shortcodes($post->post_content)));
		}
        return wp_trim_words(str_replace(PHP_EOL,'',$desc),$length,'...');
    }
endif;

// 获取分类关联标签 - 多个用,分割
if (!function_exists('cx_category_tags')) :
    function cx_category_tags($categories,$number = 10,$rand = false) {
        global $wpdb;
        $numbers = $rand ? $number * 3 : $number;
        $tags = $wpdb->get_results(
            "SELECT DISTINCT terms2.term_id as tagid, terms2.name as tagname
            FROM
                $wpdb->posts as p1
                LEFT JOIN $wpdb->term_relationships as r1 ON p1.ID = r1.object_ID
                LEFT JOIN $wpdb->term_taxonomy as t1 ON r1.term_taxonomy_id = t1.term_taxonomy_id
                LEFT JOIN $wpdb->terms as terms1 ON t1.term_id = terms1.term_id,
    
                $wpdb->posts as p2
                LEFT JOIN $wpdb->term_relationships as r2 ON p2.ID = r2.object_ID
                LEFT JOIN $wpdb->term_taxonomy as t2 ON r2.term_taxonomy_id = t2.term_taxonomy_id
                LEFT JOIN $wpdb->terms as terms2 ON t2.term_id = terms2.term_id
            WHERE
                t1.taxonomy = 'category' AND p1.post_status = 'publish' AND terms1.term_id IN (".$categories.") AND
                t2.taxonomy = 'post_tag' AND p2.post_status = 'publish'
                AND p1.ID = p2.ID
            ORDER by tagname LIMIT 0,".$numbers.""
        );
        
        if($tags) {
            if( $rand ){
                shuffle($tags);
                if( count($tags) > $number ){
                    $tags = array_slice($tags, 0,$number);
                }
            }
            return $tags;
        }        
        return false;
    }
endif;

if( !function_exists('cx_copyright_meta') ):
    function cx_copyright_meta(){
        $atagAttr = 'target="_blank"';
        if( !is_home() ){
            $atagAttr .= ' rel="nofollow"';
        }
        printf(
            '<div class="foot-copyright">%s &copy; %s. Theme by <a href="https://www.xhtheme.com/themes/meteor-theme" %s>%s</a></div>',
            get_bloginfo('name'),
            esc_html( date_i18n( esc_html__( 'Y', 'Meteor' ) ) ),
            $atagAttr,
            esc_html__( 'Meteor', 'Meteor' )
        );
    }
endif;

// 处理默认菜单
if(!function_exists('cx_menu_fallback')):
    function cx_menu_fallback(){
        $pattern = '<li class="menu-item"><a href="%s" target="_blank" class="nav-link">%s</a></li>';
        printf( 
            $pattern,
            admin_url( 'nav-menus.php' ),
            __('设置菜单','Meteor')
        );
        printf( 
            $pattern,
            esc_url( 'https://www.chenxingweb.com/docs/3716.html' ),
            __('教程指引','Meteor')
        );
    }
endif;
if(!function_exists('cx_menu_fallback_left')):
    function cx_menu_fallback_left(){
        $pattern = '<li class="menu-item"><a href="%s" target="_blank" class="nav-link">%s</a></li>';
        $_html   = '';
        $_html  .= sprintf( 
            $pattern,
            admin_url( 'nav-menus.php' ),
            __('设置菜单','Meteor')
        );
        $_html  .= sprintf( 
            $pattern,
            esc_url( 'https://www.chenxingweb.com/docs/3716.html' ),
            __('教程指引','Meteor')
        );
        printf('<li class="menu-item"><a href="javascript:;" target="_blank" class="nav-link">菜单导航</a><ul class="sub-menu">%s</ul></li>',$_html);
    }
endif;




// 文章页面包屑导航
if(!function_exists('cx_breadcrumb')):
    function cx_breadcrumb($post = null){
        if( !$post || !$post instanceof WP_Post ){
            global $post;
        }
        $pattern = '
        <li class="%s">
            <a  href="%s" title="%s">
                <span>%s</span>
            </a>
        </li>';
        $item_arr   = [];
        $item_arr[] = sprintf( $pattern, 'item-home flex-shrink-0', get_home_url(), get_bloginfo('name'), '首页' );
        $category   = get_the_category( $post->ID );
        $item_arr[] = sprintf( $pattern, 'item-category flex-shrink-0',get_category_link( $category[0] ),$category[0]->name, $category[0]->name);
        $item_arr[] = sprintf( $pattern, 'item-current line-one pe-4',get_permalink( $post->ID ),$post->post_title,$post->post_title);
        // 组合
        printf('
            <nav class="breadcrumbs" aria-label="面包屑导航">
                <ol class="breadcrumb flex-nowrap">
                %s
                </ol>
            </nav>
            ',
            join("\n",$item_arr)
        );
    }
endif;

if(!function_exists('cx_randcolor')):
    function cx_randcolor( array $data = [],$default = '' ){
        if( empty($data) ) {
            $data = [
                '#009688',
                '#2e323e',
                '#f66',
                '#1e9fff',
                '#fb7299'
            ];
        }

        $arrcount = count($data);
        $xzarrnum = mt_rand(0,$arrcount - 1);
        if( isset($data[$xzarrnum]) ){
            return $data[$xzarrnum];
        }
        return $default;
    }
endif;
if(!function_exists('cx_array_json')):
    function cx_array_json( array $data ){
        return json_encode( $data,JSON_UNESCAPED_UNICODE );
    }
endif;
