<article id="post-43" class="post is-single post-content status-publish" x-data="cxm2_Postmeta">
    <!-- 文章标题 -->
    <header class="post-header">
        <?php the_title( '<h1 class="post-title mt-3 mb-4 fs-2">', '</h1>' );?>
        <!-- 文章元信息（如作者、发布时间、分类、标签等） -->
        <?php
        $postmeta_arr   = [];
        $postmeta_arr[] = '<div class="article-meta">';
        $postmeta_arr[] = '<ul class="meta-itembox">';
        // 获取作者信息
        $author_id      = get_the_author_meta( 'ID' );
        $display_name   = get_the_author_meta( 'display_name',$author_id );
        $author_avatar  = get_avatar( $author_id, 30 );
        $postmeta_arr[] = sprintf( '<li class="list-inline-item"><a class="author me-0" href="%s">%s</a></li>', esc_url( get_author_posts_url( $author_id ) ), '<figure class="figure-avatar  btn-default userid-'.$author_id.'">'.$author_avatar.'</figure>'.$display_name );
        // 获取类别
        //$category       = get_the_category();
        $postmeta_arr[] = sprintf( '<li class="list-inline-item">%s</li>',get_the_category_list( __( '、', 'Meteor' ) ));
        // 获取日期
        $post_date      = get_the_date();
        $postmeta_arr[] = sprintf( '<li class="list-inline-item">%s</li>',$post_date );

        $postmeta_arr[] = '</ul>';
        $postmeta_arr[] = '</div>';
        echo join("\n",$postmeta_arr);
        ?>
    </header>

    <!-- 文章正文 -->
    <div class="article-body mb-4">
        <?php the_content();?>
    </div>

    <!-- 底部元信息 -->
    <div class="post-footmeta mb-4">
        <div class="row d-flex align-items-center">
            <div class="col-md-6 col-12">
                <div class="post-share justify-content-sm-start mb-3 mb-sm-0">
                    <div class="post-btnmeta">
                        <span class="post-like trans_2ms" :class="postMeta.postLike_on ? 'on' : ''" @click="_setlike"><i class="cxicon cxicon-zan-black"></i> <em style="font-style: normal" x-text="postMeta.postLike" x-show="postMeta.postLike !== 0"></em></span>
                    </div>
                    <i class="cxline-1"></i>
                    <ul class="social-icons" x-data="{'postThumb':'<?php echo cx_post_thumb();?>','postLink' : window.location.href, 'postTitle' : document.title}">
                        <li class="list-inline-item">
                            <a href="javascript:;" title="分享到微博" x-bind="weiboLink"><i class="cxicon cxicon-weibo"></i></a>
                        </li>
                        <li class="list-inline-item">
                            <a href="javascript:;" title="分享到QQ" x-bind="qqLink"><i class="cxicon cxicon-qq"></i></a>
                        </li>
                    </ul>
                </div>
            </div>
            <div class="col-md-6 col-12 text-center text-md-end">
                <div class="tags">
                    <?php
                    $post_tags = get_the_tags();
                    if( $post_tags ){
                        foreach ($post_tags as $tag) {
                            printf( '<a href="%s" rel="tag">#%s</a>', get_tag_link( $tag ),$tag->name );
                        }
                    }
                    ?>
                </div>
            </div>
        </div>
    </div>

    <div class="about-author p-4 mt-5 flex-sm-row">
        <?php
        $author_id      = get_the_author_meta( 'ID' );
        $author_name    = get_the_author_meta( 'display_name',$author_id );
        $author_link    = esc_url( get_author_posts_url( $author_id ) );
        $author_desc    = get_the_author_meta( 'description',$author_id );
        $author_avatar  = get_avatar( $author_id, 100 );
        if( !$author_desc  ){
            $author_desc = '暂无介绍....';
        }
        printf( '<div class="thumb"><a class="author" href="%s">%s</a></div>', $author_link, '<figure class="figure-avatar  btn-default userid-'.$author_id.'">'.$author_avatar.'</figure>');
        ?>
        <div class="details ps-sm-4 mt-3 mt-sm-0 text-sm-start">
            <h4 class="name"><?php the_author_posts_link();?></h4>
            <p><?php echo $author_desc;?></p>
            <ul class="social-icons list-unstyled list-inline mb-0">
                <li class="list-inline-item">
                    <a href="<?php echo $author_link;?>" class="author-link">TA的主页 <i class="cxicon cxicon-jtright font-inherit"></i></a>
                </li>
            </ul>
        </div>
    </div>

    <div class="row nextprev-post-wrapper mb-4">
        <div class="col-md-6 col-12 mb-3 mb-sm-0">
            <div class="nextprev-post prev">
                <span class="nextprev-text"> 上一篇</span>
                <h5 class="post-title">
                    <?php
                    $prev_post = get_previous_post_link( '%link' );
                    if( $prev_post ){
                        echo $prev_post;
                    }else{
                        echo '没有啦 (Ｔ▽Ｔ)';
                    }
                    ?>
                </h5>
            </div>
        </div>
        <div class="col-md-6 col-12">
            <div class="nextprev-post next text-sm-end">
                <span class="nextprev-text">下一篇</span>
                <h5 class="post-title">
                    <?php
                    $next_post = get_next_post_link( '%link' );
                    if( $next_post ){
                        echo $next_post;
                    }else{
                        echo '没有啦 (Ｔ▽Ｔ)';
                    }
                    ?>
                </h5>
            </div>
        </div>
    </div>

    <section class="comments">
        <!-- 评论区代码 -->
    </section>

    <div class="mso nobg">
        <div class="module-tit item-center noborder">
            <h3 style="font-size:1rem"><i class="cxline"></i>延伸阅读:</h3>
            <p></p>
        </div>
        <div class="module-content">
        <?php
        // The Query
        $post_id      = get_the_ID();
        $post_trem    = get_the_category($post_id);
        $hotspot_args = [
            'post_type'           => 'post',
            'post_status'         => 'publish',
            'posts_per_page'      => 5,
            'orderby'             => 'modified',
            'ignore_sticky_posts' => true,
            'cat'                 => $post_trem[0]->term_id
        ];
        $hotspot_query = new WP_Query( $hotspot_args );
        if( $hotspot_query->have_posts() ):
            while ( $hotspot_query->have_posts() ): $hotspot_query->the_post();
                get_template_part( 'template/list/list', 'blogsmall' );
            endwhile;
        else:
            printf( '<div class="nonebox"><div class="iconsvg"></div><p>%s</p></div>', __( '暂无内容!', 'Meteor' ) );
        endif;
        wp_reset_postdata();
        ?>
        </div>
    </div>
</article>